; ##############################################################################
; ##############################################################################
; ##############################################################################
STARTWERTE:
	; NULL				
	clr NULL
	; EINS				
	ldi temp,1
	mov EINS,temp
	; VOLL				
	ldi temp,255
	mov VOLL,temp
	; SRAM CHECK		
	ldi temp,'S'
	STS(adr_SRAM_CHECK),temp
	; "30.06.2023"		
	ldi temp,(ASCII_3)
	STS(adr_DIGIT7),temp
	ldi temp,(ASCII_0)
	ori temp,0b10000000		; Punkt	
	STS(adr_DIGIT6),temp
	ldi temp,(ASCII_0)
	STS(adr_DIGIT5),temp
	ldi temp,(ASCII_6)
	ori temp,0b10000000		; Punkt	
	STS(adr_DIGIT4),temp

	ldi temp,(ASCII_2)
	STS(adr_DIGIT3),temp
	ldi temp,(ASCII_0)
	STS(adr_DIGIT2),temp
	ldi temp,(ASCII_2)
	STS(adr_DIGIT1),temp
	ldi temp,(ASCII_3)
	STS(adr_DIGIT0),temp
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
WDR_INITIALISIERUNG:
	ldi TEMP,(1<<WDCE)|(1<<WDE) ; Watchdog aktivieren (max. Zeit)				
	out wdtcr,TEMP       
	ldi TEMP,(1<<WDE) | (1<<WDP2)|(1<<WDP1)|(1<<WDP0) 
	out wdtcr,temp
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
SRAM_CLEAR:
	ldi ZL, LOW (SRAM_START)
	ldi ZH, HIGH(SRAM_START)
	ldi temp,0
;-------------------------------------------------------------------------------
SRAM_CLEAR_w:
	ST z+,temp
	cpi ZH, HIGH(RAMEND-1)	; Vergleich?		
	brlo SRAM_CLEAR_w		; kleiner => SPRUNG	
	cpi ZL, LOW(RAMEND-1)	; Vergleich?		
	brlo SRAM_CLEAR_w		; kleiner => SPRUNG	
	breq SRAM_CLEAR_w		; gleich  => SPRUNG	
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
REGISTER_CLEAR:
	clr R0
	clr R1
	clr R2
	clr R3
	clr R4
	clr R5
	clr R6
	clr R7
	clr R8
	clr R9
	clr R10
	clr R11
	clr R12
	clr R13
	clr R14
	clr R15
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
PORT_INITIALISIERUNG:
	clr temp
	out DDRB, temp
	out DDRC, temp
	out DDRD, temp
	out PORTB,temp				
	out PORTC,temp				
	out PORTD,temp
;-------------------------------------------------------------------------------
	; auf AUSGANG								
	sbi (GRUEN_DDR),(GRUEN_PIN_NR)		; GRN	
	sbi (GELB_DDR) ,(GELB_PIN_NR)		; GELB	
	sbi (ROT_DDR)  ,(ROT_PIN_NR)		; ROT	
;-------------------------------------------------------------------------------
	; auf AUSGANG								
	sbi (CLOCK_DDR),(CLOCK_PIN_NR)			; Clock	
	sbi (DAT_DDR)  ,(DAT_PIN_NR)			; DAT	
;-------------------------------------------------------------------------------
	GRUEN_OFF
	GELB_OFF
	ROT_OFF
;-------------------------------------------------------------------------------
	GRUEN_ON
	rcall wait_100ms
	GRUEN_OFF
	rcall wait_100ms

	GELB_ON
	rcall wait_100ms
	GELB_OFF
	rcall wait_100ms

	ROT_ON
	rcall wait_100ms
	ROT_OFF
	rcall wait_100ms
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
PROGRAMM_CHECK:
	; NULL		
	tst NULL
	brne PROGRAMM_CHECK_ERROR
	; EINS		
	mov temp,EINS
	cpi temp,1
	brne PROGRAMM_CHECK_ERROR
	; VOLL		
	mov temp,VOLL
	cpi temp,255
	brne PROGRAMM_CHECK_ERROR
	; SRAM CHECK
	LDS temp,(adr_SRAM_CHECK)
	cpi temp,'S'
	brne PROGRAMM_CHECK_ERROR
	ret
;-------------------------------------------------------------------------------
PROGRAMM_CHECK_ERROR:
	CLI 										; Global Interrupt Disable
	rcall wait_100ms
	ROT_ON
	rcall wait_100ms
	GRUEN_OFF
	GELB_OFF
	ROT_OFF
	rjmp PROGRAMM_CHECK_ERROR
; ##############################################################################
; ##############################################################################
; ##############################################################################
