;												
; LED-Display-Dig-2R 74HC164 Reichelt 810568 	
; Bernhard.Erfurt@gmx.de						
; 06/2023										
;												
; https://www.mikrocontroller.net/topic/556211#new
;												
; LED ROT blinkt: Programm Check Error			
; LED ROT+GELB blinkt: Interrupt Error			
; LED ROT+GELB+GRN blinkt: WDR Error (nicht in dieser Version)	
;												

;												
; Anschlussbelegung PINS						
;												
; PB0 ==> LED-Clock								
; PB1 ==> LED-Data								
; PB2 ==> 										
; PB3 ==> 										
; PB4 ==> 										
; PB5 ==> 										
; PB6 ==> 										
; PB7 ==> 										
;												
; PC0 ==> 										
; PC1 ==> 										
; PC2 ==> 										
; PC3 ==> 										
; PC4 ==> 										
; PC5 ==> 										
;												
; PD0 ==> 										
; PD1 ==> 										
; PD2 ==> 										
; PD3 ==> 										
; PD4 ==> 										
; PD5 ==> LED GRN								
; PD6 ==> LED GELB								
; PD7 ==> LED ROT								
;												

; ZEICHEN-DARSTELLUNG - 7-SEGMENT				
.equ ASCII_0					=0b00111111	; 0 
.equ ASCII_1					=0b00000110	; 1 
.equ ASCII_2					=0b01011011	; 2 
.equ ASCII_3					=0b01001111	; 3 
.equ ASCII_4					=0b01100110	; 4 
.equ ASCII_5					=0b01101101	; 5 
.equ ASCII_6					=0b01111101	; 6 
.equ ASCII_7					=0b00000111	; 7 
.equ ASCII_8					=0b01111111	; 8 
.equ ASCII_9					=0b01101111	; 9 

.equ ASCII_AUS					=0b00000000	; ''
.equ ASCII_PUNKT				=0b10000000	; . 
.equ ASCII_VOLL					=0b11111111	; 8.
.equ ASCII_MINUS				=0b01000000	; - 

.equ ASCII_A					=0b01110111	; A 
.equ ASCII_B					=0b01111100	; B 
.equ ASCII_C					=0b01011000	; C 
.equ ASCII_D					=0b01011110	; D 
.equ ASCII_E					=0b01111001	; E 
.equ ASCII_F					=0b01110001	; F 

.equ ASCII_PROZ0				=0b01100011	;
.equ ASCII_PROZ1				=0b01011100	;

; ATmega8 										
.include "m8def.inc"
.include "MACRO.asm"
; LED-CP(Clock)									
.equ CLOCK_PIN_NR				= 0
.equ CLOCK_DDR					= DDRD
.equ CLOCK_PORT					= PORTD
; LED-DAT(Daten)								
.equ DAT_PIN_NR					= 1
.equ DAT_DDR					= DDRD
.equ DAT_PORT					= PORTD
; LED-GRUEN										
.equ GRUEN_PIN_NR				= 5
.equ GRUEN_DDR					= DDRD
.equ GRUEN_PORT					= PORTD
; LED-GELB										
.equ GELB_PIN_NR				= 6
.equ GELB_DDR					= DDRD
.equ GELB_PORT					= PORTD
; LED-ROT										
.equ ROT_PIN_NR					= 7
.equ ROT_DDR					= DDRD
.equ ROT_PORT					= PORTD
; SRAM-BELEGUNG ATmega8							
.equ adr_DATEN						=SRAM_START		; 0x0060 START Adresse 		

.equ adr_DIGIT_NR					=SRAM_START+5	; 0...7						

.equ adr_DIGIT0						=SRAM_START+10	; unten rechts				
.equ adr_DIGIT1						=SRAM_START+11	
.equ adr_DIGIT2						=SRAM_START+12	
.equ adr_DIGIT3						=SRAM_START+13	
.equ adr_DIGIT4						=SRAM_START+14	
.equ adr_DIGIT5						=SRAM_START+15	
.equ adr_DIGIT6						=SRAM_START+16	
.equ adr_DIGIT7						=SRAM_START+17	


.equ adr_SRAM_CHECK					=SRAM_START+943	; SRAM CHECK muss immer "S" sein	

; REGISTER										
.def NULL 	= R12
.def EINS 	= R14
.def VOLL	= R15

.def temp 	= R16
.def temp1 	= R17
.def temp2 	= R18
.def temp3 	= R19
.def temp4 	= R20
.def temp5 	= R21
.def temp6 	= R22
.def temp7 	= R23
.def temp8 	= R24
.def temp9 	= R25


.cseg					;Beginn eines Code-Segmentes
.org 0					;Startadresse=0

rjmp RESET      		; Reset Handler                           				
rjmp INTERRUPT_ERROR	;rjmp EXT_INT0   ; IRQ0 Handler                      	
rjmp INTERRUPT_ERROR	;rjmp EXT_INT1   ; IRQ1 Handler                      	
rjmp INTERRUPT_ERROR	;rjmp TIM2_COMP  ; Timer2 Compare Handler            	
rjmp INTERRUPT_ERROR	;rjmp TIM2_OVF   ; Timer2 Overflow Handler           	
rjmp INTERRUPT_ERROR	;rjmp TIM1_CAPT  ; Timer1 Capture Handler            	
rjmp INTERRUPT_ERROR	;rjmp TIM1_COMPA ; Timer1 CompareA Handler           	
rjmp INTERRUPT_ERROR	;rjmp TIM1_COMPB ; Timer1 CompareB Handler           	
rjmp INTERRUPT_ERROR	;rjmp TIM1_OVF   	  	; Timer1 Overflow Handler       
rjmp TIM0_OVF   		; Timer0 Overflow Handler       						
rjmp INTERRUPT_ERROR	;rjmp SPI_STC    ; SPI Transfer Complete Handler     	
rjmp INTERRUPT_ERROR	;rjmp ZEICHEN_EINLESEN 	; USART RX Complete Handler     
rjmp INTERRUPT_ERROR	;rjmp USART_UDRE ; UDR Empty Handler                 	
rjmp INTERRUPT_ERROR	;rjmp USART_TXC  ; USART TX Complete Handler         	
rjmp INTERRUPT_ERROR	;rjmp ADC        ; ADC Conversion Complete Handler   	
rjmp INTERRUPT_ERROR	;rjmp EE_RDY     ; EEPROM Ready Handler              	
rjmp INTERRUPT_ERROR	;rjmp ANA_COMP   ; Analog Comparator Handler         	
rjmp INTERRUPT_ERROR	;rjmp TWSI       ; Two-wire Serial Interface Handler 	
rjmp INTERRUPT_ERROR	;rjmp SPM_RDY    ; Store Program Memory Ready Handler	
;-------------------------------------------------------------------------------
; Unkorrekten Interrupt Aufruf 													
INTERRUPT_ERROR:
	GELB_ON
	ROT_ON
	rcall wait_100ms
	GRUEN_OFF
	GELB_OFF
	ROT_OFF
	rcall wait_100ms
	rjmp INTERRUPT_ERROR
;-------------------------------------------------------------------------------
RESET:                        
	ldi temp, LOW(RAMEND)					; STACK initialisieren				
    out SPL, temp
    ldi temp, HIGH(RAMEND)
    out SPH, temp
	rcall WDR_INITIALISIERUNG				; WDR_INITIALISIERUNG				
	rcall SRAM_CLEAR						; SRAM lschen						
	rcall REGISTER_CLEAR					; REGISTER-CLEAR					
	rcall STARTWERTE						; Startwerte						
	rcall TIMER0_INITIALISIERUNG			; Timer								
	rcall TIMER_AKTIVIEREN					; Timer								
	rcall PORT_INITIALISIERUNG				; LED_INITIALISIERUNG				
	rcall PROGRAMM_CHECK					; CHECK								
	sei										; Interrupts freigeben				
;-------------------------------------------------------------------------------
;-------------------------------------------------------------------------------
LOOP:
	WDR
	rcall PROGRAMM_CHECK					; CHECK								
rjmp LOOP
; ##############################################################################
; ##############################################################################
; ##############################################################################
.include "SONSTIGES.asm"
.include "TIMER.asm"
.include "WAIT.asm"

